/**
 * @fileoverview ٶȵͼĸMarker࣬⿪š
 * ûԶḻMarkerչ֣ӵ˫ק¼
 * Baidu Map API 1.2
 *
 * @author Baidu Map Api Group
 * @version 1.2
 */
/**
 * @namespace BMaplibraryBMapLibռ
 */
var BMapLib = window.BMapLib = BMapLib || {};
(function () {
    /**
     * baidu
     */
    var baidu = baidu || {
            guid: "$BAIDU$"
        };
    (function () {
        // һЩҳ漶ΨһԣҪwindow[baidu.guid]
        window[baidu.guid] = {};

        /**
         * ԴԿĿ
         * @name baidu.extend
         * @function
         * @grammar baidu.extend(target, source)
         * @param {Object} target Ŀ
         * @param {Object} source Դ
         * @returns {Object} Ŀ
         */
        baidu.extend = function (target, source) {
            for (var p in source) {
                if (source.hasOwnProperty(p)) {
                    target[p] = source[p];
                }
            }
            return target;
        };
        /**
         * @ignore
         * @namespace
         * @baidu.lang Բķװжϡģչ̳лԼԶ¼֧֡
         * @property guid Ψһʶ
         */
        baidu.lang = baidu.lang || {};

        /**
         * һǰҳΨһʶַ
         * @function
         * @grammar baidu.lang.guid()
         * @returns {String} ǰҳΨһʶַ
         */
        baidu.lang.guid = function () {
            return "TANGRAM__" + (window[baidu.guid]._counter++).toString(36);
        };

        window[baidu.guid]._counter = window[baidu.guid]._counter || 1;

        /**
         * ʵ
         * keyΪÿʵguid
         */
        window[baidu.guid]._instances = window[baidu.guid]._instances || {};

        /**
         * Tangram̳лṩһ࣬û̳ͨbaidu.lang.ClassȡԼ
         * @function
         * @name baidu.lang.Class
         * @grammar baidu.lang.Class(guid)
         * @param {string} guid    Ψһʶ
         * @meta standard
         * @remark baidu.lang.ClassʵһȫΨһıʶguid
         * guidڹ캯ɵģˣ̳baidu.lang.ClassӦֱӻ߼ӵĹ캯<br>
         * baidu.lang.ClassĹ캯вguidķʽԱ֤guidΨһԣÿʵһȫΨһguid
         */
        baidu.lang.Class = function (guid) {
            this.guid = guid || baidu.lang.guid();
            window[baidu.guid]._instances[this.guid] = this;
        };

        window[baidu.guid]._instances = window[baidu.guid]._instances || {};
        /**
         * жĿǷstringͻString
         * @name baidu.lang.isString
         * @function
         * @grammar baidu.lang.isString(source)
         * @param {Any} source Ŀ
         * @shortcut isString
         * @meta standard
         *
         * @returns {boolean} жϽ
         */
        baidu.lang.isString = function (source) {
            return '[object String]' == Object.prototype.toString.call(source);
        };
        baidu.isString = baidu.lang.isString;

        /**
         * жĿǷΪfunctionFunctionʵ
         * @name baidu.lang.isFunction
         * @function
         * @grammar baidu.lang.isFunction(source)
         * @param {Any} source Ŀ
         * @returns {boolean} жϽ
         */
        baidu.lang.isFunction = function (source) {
            return '[object Function]' == Object.prototype.toString.call(source);
        };
        /**
         * Զ¼
         * @function
         * @name baidu.lang.Event
         * @grammar baidu.lang.Event(type[, target])
         * @param {string} type     ¼ơΪ˷¼һͨķ¼Ʊ"on"(Сд)ͷ
         * @param {Object} [target]¼Ķ
         * @meta standard
         * @remark ģ飬ԶΪClass3¼չaddEventListenerremoveEventListenerdispatchEvent
         * @see baidu.lang.Class
         */
        baidu.lang.Event = function (type, target) {
            this.type = type;
            this.returnValue = true;
            this.target = target || null;
            this.currentTarget = null;
        };

        /**
         * ע¼baidu.lang.EventClassʵŻø÷
         * @grammar obj.addEventListener(type, handler[, key])
         * @param    {string}   type         Զ¼
         * @param    {Function} handler      Զ¼ʱӦõõĻص
         * @param    {string}   [key]        Ϊ¼ָƣƳʱʹáṩĬΪһȫΨһkey
         * @remark    ¼ִСдԶ¼ƲСд"on"ͷ÷"on"ٽжϣ"click""onclick"ᱻΪͬһ¼
         */
        baidu.lang.Class.prototype.addEventListener = function (type, handler, key) {
            if (!baidu.lang.isFunction(handler)) {
                return;
            }
            !this.__listeners && (this.__listeners = {});
            var t = this.__listeners,
                id;
            if (typeof key == "string" && key) {
                if (/[^\w\-]/.test(key)) {
                    throw ("nonstandard key:" + key);
                } else {
                    handler.hashCode = key;
                    id = key;
                }
            }
            type.indexOf("on") != 0 && (type = "on" + type);
            typeof t[type] != "object" && (t[type] = {});
            id = id || baidu.lang.guid();
            handler.hashCode = id;
            t[type][id] = handler;
        };

        /**
         * Ƴ¼baidu.lang.EventClassʵŻø÷
         * @grammar obj.removeEventListener(type, handler)
         * @param {string}   type     ¼
         * @param {Function|string} handler  ҪƳ¼߼key
         * @remark    ڶhandlerûб󶨵ӦԶ¼УʲôҲ
         */
        baidu.lang.Class.prototype.removeEventListener = function (type, handler) {
            if (baidu.lang.isFunction(handler)) {
                handler = handler.hashCode;
            } else if (!baidu.lang.isString(handler)) {
                return;
            }
            !this.__listeners && (this.__listeners = {});
            type.indexOf("on") != 0 && (type = "on" + type);
            var t = this.__listeners;
            if (!t[type]) {
                return;
            }
            t[type][handler] && delete t[type][handler];
        };

        /**
         * ɷԶ¼ʹð󶨵Զ¼ĺᱻִСbaidu.lang.EventClassʵŻø÷
         * @grammar obj.dispatchEvent(event, options)
         * @param {baidu.lang.Event|String} event    Event󣬻¼(1.1.1֧)
         * @param {Object} options չ,ԼֵչEvent(1.2֧)
         * @remark ͨaddEventListenr󶨵Զ¼ص֮⣬ֱӰ󶨵Զ¼
         * 磺<br>
         * myobj.onMyEvent = function(){}<br>
         * myobj.addEventListener("onMyEvent", function(){});
         */
        baidu.lang.Class.prototype.dispatchEvent = function (event, options) {
            if (baidu.lang.isString(event)) {
                event = new baidu.lang.Event(event);
            }
            !this.__listeners && (this.__listeners = {});
            options = options || {};
            for (var i in options) {
                event[i] = options[i];
            }
            var i, t = this.__listeners,
                p = event.type;
            event.target = event.target || this;
            event.currentTarget = this;
            p.indexOf("on") != 0 && (p = "on" + p);
            baidu.lang.isFunction(this[p]) && this[p].apply(this, arguments);
            if (typeof t[p] == "object") {
                for (i in t[p]) {
                    t[p][i].apply(this, arguments);
                }
            }
            return event.returnValue;
        };

        /**
         * @ignore
         * @namespace baidu.dom
         * domķ
         */
        baidu.dom = baidu.dom || {};

        /**
         * ĵлȡָDOMԪ
         * **ڲ**
         *
         * @param {string|HTMLElement} id ԪصidDOMԪ
         * @meta standard
         * @return {HTMLElement} DOMԪأڣnullϷֱӷز
         */
        baidu.dom._g = function (id) {
            if (baidu.lang.isString(id)) {
                return document.getElementById(id);
            }
            return id;
        };
        baidu._g = baidu.dom._g;

        /**
         * @ignore
         * @namespace baidu.event Ե¼װ
         * @property target    ¼ĴԪ
         * @property pageX        ¼x
         * @property pageY        ¼y
         * @property keyCode    ¼ļֵ
         */
        baidu.event = baidu.event || {};

        /**
         * ¼Ĵ洢
         * @private
         * @meta standard
         */
        baidu.event._listeners = baidu.event._listeners || [];

        /**
         * ΪĿԪ¼
         * @name baidu.event.on
         * @function
         * @grammar baidu.event.on(element, type, listener)
         * @param {HTMLElement|string|window} element ĿԪػĿԪid
         * @param {string} type ¼
         * @param {Function} listener Ҫӵļ
         * @remark
         *
         1. ֿ֧¼<br>
         2. ķΪ¼Էֹiframe¼ص¼ȡʧ

         * @shortcut on
         * @meta standard
         * @see baidu.event.un
         * @returns {HTMLElement|window} ĿԪ
         */
        baidu.event.on = function (element, type, listener) {
            type = type.replace(/^on/i, '');
            element = baidu.dom._g(element);

            var realListener = function (ev) {
                    listener.call(element, ev);
                },
                lis = baidu.event._listeners,
                filter = baidu.event._eventFilter,
                afterFilter, realType = type;
            type = type.toLowerCase();
            if (filter && filter[type]) {
                afterFilter = filter[type](element, type, realListener);
                realType = afterFilter.type;
                realListener = afterFilter.listener;
            }
            if (element.addEventListener) {
                element.addEventListener(realType, realListener, false);
            } else if (element.attachEvent) {
                element.attachEvent('on' + realType, realListener);
            }
            lis[lis.length] = [element, type, listener, realListener, realType];
            return element;
        };
        baidu.on = baidu.event.on;

        /**
         * ΪĿԪƳ¼
         * @name baidu.event.un
         * @function
         * @grammar baidu.event.un(element, type, listener)
         * @param {HTMLElement|string|window} element ĿԪػĿԪid
         * @param {string} type ¼
         * @param {Function} listener ҪƳļ
         * @shortcut un
         * @meta standard
         * @see baidu.event.on
         *
         * @returns {HTMLElement|window} ĿԪ
         */
        baidu.event.un = function (element, type, listener) {
            element = baidu.dom._g(element);
            type = type.replace(/^on/i, '').toLowerCase();

            var lis = baidu.event._listeners,
                len = lis.length,
                isRemoveAll = !listener,
                item, realType, realListener;
            while (len--) {
                item = lis[len];
                if (item[1] === type && item[0] === element && (isRemoveAll || item[2] === listener)) {
                    realType = item[4];
                    realListener = item[3];
                    if (element.removeEventListener) {
                        element.removeEventListener(realType, realListener, false);
                    } else if (element.detachEvent) {
                        element.detachEvent('on' + realType, realListener);
                    }
                    lis.splice(len, 1);
                }
            }

            return element;
        };
        baidu.un = baidu.event.un;

        /**
         * ֹ¼ĬΪ
         * @name baidu.event.preventDefault
         * @function
         * @grammar baidu.event.preventDefault(event)
         * @param {Event} event ¼
         * @meta standard
         */
        baidu.preventDefault = baidu.event.preventDefault = function (event) {
            if (event.preventDefault) {
                event.preventDefault();
            } else {
                event.returnValue = false;
            }
        };
    })();

    /**
     * @exports RichMarker as BMapLib.RichMarker
     */
    var RichMarker =
    /**
     * RichMarkerĹ캯
     * @class Marker࣬ʵַḻMarkerչЧ
     *
     * @constructor
     * @param {String | HTMLElement} content ûԶMarkerݣַҲdomڵ
     * @param {BMap.Point} position markerλ
     * @param {Json} RichMarkerOptions ѡǱѡ<br />
     * {"<b>anchor</b>" : {BMap.Size} Markerĵλƫֵ,
      * <br />"<b>enableDragging</b>" : {Boolean} ǷקĬΪfalse}
     *
     * @example <b>οʾ</b>
     * var map = new BMap.Map("container");
     * map.centerAndZoom(new BMap.Point(116.309965, 40.058333), 17);
     * var htm = "<div style='background:#E7F0F5;color:#0082CB;border:1px solid #333'>"
     *              +     "ӭʹðٶȵͼ"
     *              +     "<img src='http://map.baidu.com/img/logo-map.gif' border='0' />"
     *              + "</div>";
     * var point = new BMap.Point(116.30816, 40.056863);
     * var myRichMarkerObject = new BMapLib.RichMarker(htm, point, {"anchor": new BMap.Size(-72, -84), "enableDragging": true});
     * map.addOverlay(myRichMarkerObject);
     */
        BMapLib.RichMarker = function (content, position, opts) {
            if (!content || !position || !(position instanceof BMap.Point)) {
                return;
            }

            /**
             * map
             * @private
             * @type {Map}
             */
            this._map = null;

            /**
             * Marker
             * @private
             * @type {String | HTMLElement}
             */
            this._content = content;

            /**
             * markerʾλ
             * @private
             * @type {BMap.Point}
             */
            this._position = position;

            /**
             * marker
             * @private
             * @type {HTMLElement}
             */
            this._container = null;

            /**
             * markerĳߴ
             * @private
             * @type {BMap.Size}
             */
            this._size = null;

            opts = opts || {};
            /**
             * _optsĬϲֵ
             * ͨûoptsĬϲֵ
             * @private
             * @type {Json}
             */
            this._opts = baidu.extend(
                baidu.extend(this._opts || {}, {

                    /**
                     * MarkerǷק
                     * @private
                     * @type {Boolean}
                     */
                    enableDragging: false,

                    /**
                     * Markerƫ
                     * @private
                     * @type {BMap.Size}
                     */
                    anchor: new BMap.Size(0, 0)
                }), opts);
        }

    // ̳и
    RichMarker.prototype = new BMap.Overlay();

    /**
     * ʼʵԶ帲initialize
     * ҪMarkerԶݣ¼
     *
     * @private
     * @param {BMap} map mapʵ
     * @return {Dom} Զɵdomڵ
     */
    RichMarker.prototype.initialize = function (map) {
        var me = this,
            div = me._container = document.createElement("div");
        me._map = map;
        baidu.extend(div.style, {
            position: "absolute",
            zIndex: BMap.Overlay.getZIndex(me._position.lat),
            // background: "#FFF",
            cursor: "pointer"
        });
        map.getPanes().labelPane.appendChild(div);

        // ûԶ
        me._appendContent();
        // ¼
        me._setEventDispath();
        // ȡĸ߿
        me._getContainerSize();

        return div;
    }

    /**
     * ΪԶMarker趨ʾλãʵԶ帲draw
     *
     * @private
     */
    RichMarker.prototype.draw = function () {
        var map = this._map,
            anchor = this._opts.anchor,
            pixel = map.pointToOverlayPixel(this._position);
        this._container.style.left = pixel.x + anchor.width + "px";
        this._container.style.top = pixel.y + anchor.height + "px";
    }

    /**
     * Markerק
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.enableDragging();
     */
    RichMarker.prototype.enableDragging = function () {
        this._opts.enableDragging = true;
    }

    /**
     * Markerק
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.disableDragging();
     */
    RichMarker.prototype.disableDragging = function () {
        this._opts.enableDragging = false;
    }

    /**
     * ȡMarkerǷܱק״̬
     * @return {Boolean} trueΪקfalseΪܱק
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.isDraggable();
     */
    RichMarker.prototype.isDraggable = function () {
        return this._opts.enableDragging;
    }

    /**
     * ȡMarkerʾλ
     * @return {BMap.Point} ʾλ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.getPosition();
     */
    RichMarker.prototype.getPosition = function () {
        return this._position;
    }

    /**
     * Markerʾλ
     * @param {BMap.Point} position Ҫõλ
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.setPosition(new BMap.Point(116.30816, 40.056863));
     */
    RichMarker.prototype.setPosition = function (position) {
        if (!position instanceof BMap.Point) {
            return;
        }
        this._position = position;
        this.draw();
    }

    /**
     * ȡMarkerƫ
     * @return {BMap.Size} Markerƫ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.getAnchor();
     */
    RichMarker.prototype.getAnchor = function () {
        return this._opts.anchor;
    }

    /**
     * Markerƫ
     * @param {BMap.Size} anchor Ҫõƫ
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.setAnchor(new BMap.Size(-72, -84));
     */
    RichMarker.prototype.setAnchor = function (anchor) {
        if (!anchor instanceof BMap.Size) {
            return;
        }
        this._opts.anchor = anchor;
        this.draw();
    }

    /**
     * ûԶ
     *
     * @private
     * @return ޷ֵ
     */
    RichMarker.prototype._appendContent = function () {
        var content = this._content;
        // ûַҪתdomڵ
        if (typeof content == "string") {
            var div = document.createElement('DIV');
            div.innerHTML = content;
            if (div.childNodes.length == 1) {
                content = (div.removeChild(div.firstChild));
            } else {
                var fragment = document.createDocumentFragment();
                while (div.firstChild) {
                    fragment.appendChild(div.firstChild);
                }
                content = fragment;
            }
        }
        this._container.innerHTML = "";
        this._container.appendChild(content);
    }

    /**
     * ȡMarker
     * @return {String | HTMLElement} ǰ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.getContent();
     */
    RichMarker.prototype.getContent = function () {
        return this._content;
    }

    /**
     * Marker
     * @param {String | HTMLElement} content Ҫõ
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * var htm = "<div style='background:#E7F0F5;color:#0082CB;border:1px solid #333'>"
     *              +     "ӭʹðٶȵͼAPI"
     *              +     "<img src='http://map.baidu.com/img/logo-map.gif' border='0' />"
     *              + "</div>";
     * myRichMarkerObject.setContent(htm);
     */
    RichMarker.prototype.setContent = function (content) {
        if (!content) {
            return;
        }
        // 洢ûMarkerʾ
        this._content = content;
        // ӽ
        this._appendContent();
    }

    /**
     * ȡMarkerĸ߿
     *
     * @private
     * @return {BMap.Size} ǰ߿
     */
    RichMarker.prototype._getContainerSize = function () {
        if (!this._container) {
            return;
        }
        var h = this._container.offsetHeight;
        var w = this._container.offsetWidth;
        this._size = new BMap.Size(w, h);
    }

    /**
     * ȡMarkerĿ
     * @return {Number} ǰ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.getWidth();
     */
    RichMarker.prototype.getWidth = function () {
        if (!this._size) {
            return;
        }
        return this._size.width;
    }

    /**
     * MarkerĿ
     * @param {Number} width ҪõĿ
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.setWidth(300);
     */
    RichMarker.prototype.setWidth = function (width) {
        if (!this._container) {
            return;
        }
        this._container.style.width = width + "px";
        this._getContainerSize();
    }

    /**
     * ȡMarkerĸ߶
     * @return {Number} ǰ߶
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.getHeight();
     */
    RichMarker.prototype.getHeight = function () {
        if (!this._size) {
            return;
        }
        return this._size.height;
    }

    /**
     * Markerĸ߶
     * @param {Number} height Ҫõĸ߶
     * @return ޷ֵ
     *
     * @example <b>οʾ</b>
     * myRichMarkerObject.setHeight(200);
     */
    RichMarker.prototype.setHeight = function (height) {
        if (!this._container) {
            return;
        }
        this._container.style.height = height + "px";
        this._getContainerSize();
    }

    /**
     * Markerĸ¼
     *
     * @private
     * @return ޷ֵ
     */
    RichMarker.prototype._setEventDispath = function () {
        var me = this,
            div = me._container,
            isMouseDown = false,
        // Ƿ£жƶеק
            startPosition = null; // קʱ갴µĳʼλãקĸ

        // ͨeȡǰλ
        function _getPositionByEvent(e) {
            var e = window.event || e,
                x = e.pageX || e.clientX || 0,
                y = e.pageY || e.clientY || 0,
                pixel = new BMap.Pixel(x, y),
                point = me._map.pixelToPoint(pixel);
            return {
                "pixel": pixel,
                "point": point
            };
        }

        // ¼
        baidu.on(div, "onclick", function (e) {
            /**
             * Markerʱɷ¼Ľӿ
             * @name RichMarker#onclick
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
              * <br />"<b>type</b>{String} ¼}
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("onclick", function(e) {
              *     alert(e.type);
              * });
             */
            _dispatchEvent(me, "onclick");
            _stopAndPrevent(e);
        });

        // ˫¼
        baidu.on(div, "ondblclick", function (e) {
            var position = _getPositionByEvent(e);
            /**
             * ˫Markerʱɷ¼Ľӿ
             * @name RichMarker#ondblclick
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
              * <br />"<b>type</b>{String} ¼,
              * <br />"<b>point</b>{BMap.Point} ,
              * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("ondblclick", function(e) {
              *     alert(e.type);
              * });
             */
            _dispatchEvent(me, "ondblclick", {
                "point": position.point,
                "pixel": position.pixel
            });
            _stopAndPrevent(e);
        });

        // ¼
        div.onmouseover = function (e) {
            var position = _getPositionByEvent(e);
            /**
             * ƵMarkerʱɷ¼Ľӿ
             * @name RichMarker#onmouseover
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
              * <br />"<b>type</b>{String} ¼,
              * <br />"<b>point</b>{BMap.Point} ,
              * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("onmouseover", function(e) {
              *     alert(e.type);
              * });
             */
            _dispatchEvent(me, "onmouseover", {
                "point": position.point,
                "pixel": position.pixel
            });
            _stopAndPrevent(e);
        }

        // Ƴ¼
        div.onmouseout = function (e) {
            var position = _getPositionByEvent(e);
            /**
             * ƳMarkerʱɷ¼Ľӿ
             * @name RichMarker#onmouseout
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
              * <br />"<b>type</b>{String} ¼,
              * <br />"<b>point</b>{BMap.Point} ,
              * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("onmouseout", function(e) {
              *     alert(e.type);
              * });
             */
            _dispatchEvent(me, "onmouseout", {
                "point": position.point,
                "pixel": position.pixel
            });
            _stopAndPrevent(e);
        }

        // 굯¼
        var mouseUpEvent = function (e) {
            var position = _getPositionByEvent(e);
            /**
             * Markerϵʱɷ¼Ľӿ
             * @name RichMarker#onmouseup
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
                  * <br />"<b>type</b>{String} ¼,
                  * <br />"<b>point</b>{BMap.Point} ,
                  * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("onmouseup", function(e) {
                  *     alert(e.type);
                  * });
             */
            _dispatchEvent(me, "onmouseup", {
                "point": position.point,
                "pixel": position.pixel
            });

            if (me._container.releaseCapture) {
                baidu.un(div, "onmousemove", mouseMoveEvent);
                baidu.un(div, "onmouseup", mouseUpEvent);
            } else {
                baidu.un(window, "onmousemove", mouseMoveEvent);
                baidu.un(window, "onmouseup", mouseUpEvent);
            }

            // жǷҪק¼Ĵ
            if (!me._opts.enableDragging) {
                _stopAndPrevent(e);
                return;
            }
            // קʱͷ겶
            me._container.releaseCapture && me._container.releaseCapture();
            /**
             * קMarkerʱɷ¼Ľӿ
             * @name RichMarker#ondragend
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
                  * <br />"<b>type</b>{String} ¼,
                  * <br />"<b>point</b>{BMap.Point} ,
                  * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("ondragend", function(e) {
                  *     alert(e.type);
                  * });
             */
            _dispatchEvent(me, "ondragend", {
                "point": position.point,
                "pixel": position.pixel
            });
            isMouseDown = false;
            startPosition = null;
            // ק
            me._setCursor("dragend");
            // קзֱֹѡ
            me._container.style['MozUserSelect'] = '';
            me._container.style['KhtmlUserSelect'] = '';
            me._container.style['WebkitUserSelect'] = '';
            me._container['unselectable'] = 'off';
            me._container['onselectstart'] = function () {
            };

            _stopAndPrevent(e);
        }

        // ƶ¼
        var mouseMoveEvent = function (e) {
            // жǷҪק¼Ĵ
            if (!me._opts.enableDragging || !isMouseDown) {
                return;
            }
            var position = _getPositionByEvent(e);

            // 㵱ǰmarkerӦڵλ
            var startPixel = me._map.pointToPixel(me._position);
            var x = position.pixel.x - startPosition.x + startPixel.x;
            var y = position.pixel.y - startPosition.y + startPixel.y;

            startPosition = position.pixel;
            me._position = me._map.pixelToPoint(new BMap.Pixel(x, y));
            me.draw();
            // קе
            me._setCursor("dragging");
            /**
             * קMarkerĹУɷ¼Ľӿ
             * @name RichMarker#ondragging
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
                  * <br />"<b>type</b>{String} ¼,
                  * <br />"<b>point</b>{BMap.Point} ,
                  * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("ondragging", function(e) {
                  *     alert(e.type);
                  * });
             */
            _dispatchEvent(me, "ondragging", {
                "point": position.point,
                "pixel": position.pixel
            });
            _stopAndPrevent(e);
        }

        // 갴¼
        baidu.on(div, "onmousedown", function (e) {
            var position = _getPositionByEvent(e);
            /**
             * Markerϰʱɷ¼Ľӿ
             * @name RichMarker#onmousedown
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
                  * <br />"<b>type</b>{String} ¼,
                  * <br />"<b>point</b>{BMap.Point} ,
                  * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("onmousedown", function(e) {
                  *     alert(e.type);
                  * });
             */
            _dispatchEvent(me, "onmousedown", {
                "point": position.point,
                "pixel": position.pixel
            });

            if (me._container.setCapture) {
                baidu.on(div, "onmousemove", mouseMoveEvent);
                baidu.on(div, "onmouseup", mouseUpEvent);
            } else {
                baidu.on(window, "onmousemove", mouseMoveEvent);
                baidu.on(window, "onmouseup", mouseUpEvent);
            }

            // жǷҪק¼Ĵ
            if (!me._opts.enableDragging) {
                _stopAndPrevent(e);
                return;
            }
            startPosition = position.pixel;
            /**
             * ʼקMarkerʱɷ¼Ľӿ
             * @name RichMarker#ondragstart
             * @event
             * @param {Event Object} e ص᷵event·ֵ
             * <br />{"<b>target</b> : {BMap.Overlay} ¼Ԫ,
                  * <br />"<b>type</b>{String} ¼,
                  * <br />"<b>point</b>{BMap.Point} ,
                  * <br />"<b>pixel</b>{BMap.Pixel} }
             *
             * @example <b>οʾ</b>
             * myRichMarkerObject.addEventListener("ondragstart", function(e) {
                  *     alert(e.type);
                  * });
             */
            _dispatchEvent(me, "ondragstart", {
                "point": position.point,
                "pixel": position.pixel
            });
            isMouseDown = true;
            // קʼ
            me._setCursor("dragstart");
            // קʼʱ겶
            me._container.setCapture && me._container.setCapture();
            // קзֱֹѡ
            me._container.style['MozUserSelect'] = 'none';
            me._container.style['KhtmlUserSelect'] = 'none';
            me._container.style['WebkitUserSelect'] = 'none';
            me._container['unselectable'] = 'on';
            me._container['onselectstart'] = function () {
                return false;
            };
            _stopAndPrevent(e);
        });
    }

    /**
     * קе
     *
     * @private
     * @param {string} cursorType Ҫõ
     */
    RichMarker.prototype._setCursor = function (cursorType) {
        var cursor = '';
        var cursorStylies = {
            "moz": {
                "dragstart": "-moz-grab",
                "dragging": "-moz-grabbing",
                "dragend": "pointer"
            },
            "other": {
                "dragstart": "move",
                "dragging": "move",
                "dragend": "pointer"
            }
        };

        if (navigator.userAgent.indexOf('Gecko/') !== -1) {
            cursor = cursorStylies.moz[cursorType];
        } else {
            cursor = cursorStylies.other[cursorType];
        }

        if (this._container.style.cursor != cursor) {
            this._container.style.cursor = cursor;
        }
    }

    /**
     * ɾMarker
     *
     * @private
     * @return ޷ֵ
     */
    RichMarker.prototype.remove = function () {
        _dispatchEvent(this, "onremove");
        // ϵ¼
        if (this._container) {
            _purge(this._container);
        }
        // ɾ
        if (this._container && this._container.parentNode) {
            this._container.parentNode.removeChild(this._container);
        }
    }

    /**
     * ɷ¼
     *
     * @private
     * @param {Object} instance ɷ¼ʵ
     * @param {String} type ɷ¼
     * @param {Json} opts ɷ¼ӵĲѡ
     */
    function _dispatchEvent(instance, type, opts) {
        type.indexOf("on") != 0 && (type = "on" + type);
        var event = new baidu.lang.Event(type);
        if (!!opts) {
            for (var p in opts) {
                event[p] = opts[p];
            }
        }
        instance.dispatchEvent(event);
    }

    /**
     * DOM¼ֹѭ
     *
     * @type {DOM} dom Ҫdom
     */
    function _purge(dom) {
        if (!dom) {
            return;
        }
        var attrs = dom.attributes,
            name = "";
        if (attrs) {
            for (var i = 0, n = attrs.length; i < n; i++) {
                name = attrs[i].name;
                if (typeof dom[name] === "function") {
                    dom[name] = null;
                }
            }
        }
        var child = dom.childnodes;
        if (child) {
            for (var i = 0, n = child.length; i < n; i++) {
                _purge(dom.childnodes[i]);
            }
        }
    }

    /**
     * ֹͣ¼ðݴ
     *
     * @type {Event} e e
     */
    function _stopAndPrevent(e) {
        var e = window.event || e;
        e.stopPropagation ? e.stopPropagation() : e.cancelBubble = true;
        return baidu.preventDefault(e);
    }
})();