var renameCitys = [{"baiduCity": "阿克苏地区", "city": "阿克苏"},
    {"baiduCity": "阿勒泰地区", "city": "阿勒泰"},
    {"baiduCity": "阿里地区", "city": "阿里"},
    {"baiduCity": "博尔塔拉蒙古自治州", "city": "博尔塔拉"},
    {"baiduCity": "昌都地区", "city": "昌都"},
    {"baiduCity": "昌吉回族自治州", "city": "昌吉"},
    {"baiduCity": "白沙黎族自治县", "city": "白沙"},
    {"baiduCity": "保亭黎族苗族自治县", "city": "保亭"},
    {"baiduCity": "巴音郭楞蒙古自治州", "city": "巴音郭楞"},
    {"baiduCity": "毕节地区", "city": "毕节"},
    {"baiduCity": "昌都地区", "city": "昌都"},
    {"baiduCity": "昌江黎族自治县", "city": "昌江"},
    {"baiduCity": "楚雄彝族自治州", "city": "楚雄"},
    {"baiduCity": "澄迈县", "city": "澄迈"},
    {"baiduCity": "定安县", "city": "定安"},
    {"baiduCity": "大兴安岭地区", "city": "大兴安岭"},
    {"baiduCity": "迪庆藏族自治州", "city": "迪庆州"},
    {"baiduCity": "德宏傣族景颇族自治州", "city": "德宏州"},
    {"baiduCity": "恩施土家族苗族自治州", "city": "恩施"},
    {"baiduCity": "甘南藏族自治州", "city": "甘南"},
    {"baiduCity": "甘孜藏族自治州", "city": "甘孜州"},
    {"baiduCity": "果洛藏族自治州", "city": "果洛州"},
    {"baiduCity": "哈密地区", "city": "哈密"},
    {"baiduCity": "海北藏族自治州", "city": "海北州"},
    {"baiduCity": "海南藏族自治州", "city": "海南州"},
    {"baiduCity": "海西蒙古族藏族自治州", "city": "海西州"},
    {"baiduCity": "海东地区", "city": "海东"},
    {"baiduCity": "和田地区", "city": "和田"},
    {"baiduCity": "红河哈尼族彝族自治州", "city": "红河"},
    {"baiduCity": "黄南藏族自治州", "city": "黄南州"},
    {"baiduCity": "喀什地区", "city": "喀什"},
    {"baiduCity": "克孜勒苏柯尔克孜自治州", "city": "克孜勒苏"},
    {"baiduCity": "乐东黎族自治县", "city": "乐东"},
    {"baiduCity": "凉山彝族自治州", "city": "凉山州"},
    {"baiduCity": "临高县", "city": "临高"},
    {"baiduCity": "临夏回族自治州", "city": "临夏"},
    {"baiduCity": "陵水黎族自治县", "city": "陵水"},
    {"baiduCity": "林芝地区", "city": "林芝"},
    {"baiduCity": "那曲地区", "city": "那曲"},
    {"baiduCity": "怒江傈僳族自治州", "city": "怒江州"},
    {"baiduCity": "琼中黎族苗族自治县", "city": "琼中"},
    {"baiduCity": "黔东南苗族侗族自治州", "city": "黔东南"},
    {"baiduCity": "黔南布依族苗族自治州", "city": "黔南"},
    {"baiduCity": "黔西南布依族苗族自治州", "city": "黔西南"},
    {"baiduCity": "日喀则地区", "city": "日喀则"},
    {"baiduCity": "山南地区", "city": "山南"},
    {"baiduCity": "神农架林区", "city": "神农架"},
    {"baiduCity": "塔城地区", "city": "塔城"},
    {"baiduCity": "铜仁地区", "city": "铜仁"},
    {"baiduCity": "吐鲁番地区", "city": "吐鲁番"},
    {"baiduCity": "屯昌县", "city": "屯昌"},
    {"baiduCity": "文山壮族苗族自治州", "city": "文山州"},
    {"baiduCity": "西双版纳傣族自治州", "city": "西双版纳州"},
    {"baiduCity": "湘西土家族苗族自治州", "city": "湘西"},
    {"baiduCity": "延边朝鲜族自治州", "city": "延边"},
    {"baiduCity": "伊犁哈萨克自治州", "city": "伊犁"},
    {"baiduCity": "玉树藏族自治州", "city": "玉树州"}];
 String.prototype.startWith=function(str){     
  var reg=new RegExp("^"+str);     
  return reg.test(this);        
}  

String.prototype.endWith=function(str){     
  var reg=new RegExp(str+"$");     
  return reg.test(this);        
}
/**
 * 把百度的城市格式化成房价网的城市
 * @param baiduCity
 * @returns {string}
 */
function formatBaiduCity(baiduCity) {
    var newCity = "";
    for (var i = 0; i < renameCitys.length; i++) {
        if (renameCitys[i].baiduCity == baiduCity) {
            newCity = renameCitys[i].city;
            break;
        }
    }
    if (newCity == "" && baiduCity && baiduCity.endWith("市")) {
    	newCity = baiduCity.substring(0,baiduCity.length-1);
    }
    return newCity;
}
