var sendPhoneCode =	new Vue({
	el:'#sendPhoneCode',
	methods:{
	}
})

function sendCode(){
	var mobile = $("#input_phoneNumber").val();
	if(checkPhoneNum(mobile)){
		timer.start();
		axios.post("/rest/user/sendMobileCode", {mobile: mobile})
		.then(function (response) {
			var data = response.data
			if(data.code==200){
				$.toast("短信验证码发送成功,请注意查收！")
			}else{
				$.toast("验证码发送失败")
				 timer.cancel()
			}
		})
	}
}
function checkPhoneNum(phone){
	var reg=11&& /^((13|14|15|17|18)[0-9]{1}\d{8})$/;
	if(phone==''){
		$.toast("请输入手机号码");
		return false;
	}else if(!reg.test(phone)){
		$.toast("手机格式不正确");
		return false;
	}else{
			return true;
	}
}
//验证码倒计时
timer = {
	    countdown:60,
	    start:function(){
	        countdown = 60
	        $(".sendCode").hide()
	        $(".waiting").empty().append(countdown + " s").show()
	        timer.down()
	    },
	    down:function(){
	        countdown --
	        $(".waiting").empty().append(countdown + " s")
	        if(countdown <= 0){
	            $(".sendCode").show()
	            $(".waiting").hide()
	        }else{
	            setTimeout(timer.down, 1000)
	        }
	    },
	    cancel:function(){
	        countdown = 0
	    }
	}

/* 错误提示-快捷登录 */
$("#login_btn").on("click", function () {
	var phoneNum = $("#input_phoneNumber").val();
	var code = $("#input_codeSms").val();
	var protocal = $(".check").find(".checkImg").css("display");
	if(checkPhoneNum(phoneNum)){
		if(code == ""){
			$.toast("请输入验证码");
			return false;
		}
		if(protocal != "block"){
			$.toast("请同意服务协议");
			return false;
		}
		plus.nativeUI.showWaiting();
		axios.post("/rest/user/smsLogin", 
			{mobile: phoneNum,smsCode:code,province:province,city:city,region:region,pushClientId:getPushInfo(),deviceId:plus.device.uuid}
		).then(function (response) {
			var resData = response.data;
	    	if (resData.status) {
	    		// 用户登录成功的TOKEN
	    		var data = resData.data;
	    		localStorage.setItem("user_token", data.token);
	    		localStorage.setItem("user_token_add_time", new Date().getTime());
	    		localStorage.setItem("user_id", data.uid);
	    		$.toast(resData.message);
	    		if (data.firstLogin) {
	    			// 显示设置密码页面
	    			clicked('../user/updatePass.html',true,false,{},{},function(){
						back();
					})
	    		} else {
	    			back();
	    		}
	    		
	    	} else {
	    		$.toast(resData.message);
	    	}
	    	plus.nativeUI.closeWaiting();
		}).catch(function (error) {
	       $.toast(error);
	       plus.nativeUI.closeWaiting();
	    });
	}	
});
