//加载flag
var mf_loading = false;
//最多可加载的条目
var mf_maxItems = 100;
//上次加载的序号小区
var mf_lastIndex = 0;
//每次加载添加多少条目
var mf_itemsPerLoad = 10;
var mf_curpage = 1;
var mf_totalCount = 0;

function addEstate(number, lastIndex) {
	mf_curpage = mf_lastIndex/mf_itemsPerLoad + 1;
	axios.get("/rest/myCollection/loadCollections",{params:{pageSize:mf_itemsPerLoad,page:mf_curpage}}).then(function(response){
		
	data = response.data;
     
    if(data['results']==null || data['results'].length==0) {
        $('#loadTip2').remove();
        //$('.infinite-scroll-bottom #tab1').html("<div class='noData'><img src='../images/noData.png'><p>您还没有关注小区</p></div>");
        return;
    }
    mf_totalCount = data.totalCount;
    $("#mf_num").html("关注("+mf_totalCount+")")
    // 生成新条目的HTML
    var html = '';
    $.each(data['results'], function(i){
		var tags = this.tags;
		var tagStr = "";
		if(tags!=null&&tags.length>0){
			for(var j=0;j<tags.length;j++){
				if(j<3){
					var tag = tags[j];
					tagStr = tagStr + '<small>'+tag+'</small>';
				}
			}
		}
		var starStr = ''
		var index = this.index;
		if(index==0){
			var starStr = '暂无'
		}else{
			var totalHalfStar = Math.round(Math.round(index/5)/2) //总半星
			var starNum = Math.floor(totalHalfStar/2) 
			var halfStarNum = totalHalfStar%2
			var noneStarNum = 5-starNum-halfStarNum
			for(i=0;i<starNum;i++){
				starStr+='<i class="icon icon-star01"></i>'
			}
			for(i=0;i<halfStarNum;i++){
				starStr+='<i class="icon icon-star02"></i>'
			}
			for(i=0;i<noneStarNum;i++){
				starStr+='<i class="icon icon-star"></i>'
			}
		}
    	html+= '<li>'+
					'<a onclick="gotoDistrictDetail(\''+this.city+'\',\''+this.region+'\',\''+this.name+'\')" class="item-content">'+
						'<div class="item-inner">'+
							'<div class="item-title-row">'+
								'<div class="item-title">'+this.name+'</div>'+
								'<div class="item-after">￥'+(this.avgPrice?this.avgPrice+ '元/㎡':'暂无')+'</div>'+
							'</div>'+
							'<div class="item-title-row">'+
								'<div class="item-title"><i class="icon icon-address03"></i><small>'+(this.address?(this.city+this.region+this.address):'')+'</small></div>'+
//								'<div class="item-after"><span>'+(this.distance?"距您"+this.distance+"m":"暂无")+'</span></div>'+
							'</div>'+
							'<div class="item-subtitle">'+
								'<div>潜力指数: <span class="star">'+starStr+'</span></div>'+
								'<div>近30天涨跌幅: <em class="down">'+(this.oneMonthUpDownRange?(this.oneMonthUpDownRange>0?(this.oneMonthUpDownRange+'%<i class="icon icon-arrow-red"></i>'):(this.oneMonthUpDownRange<0?(-this.oneMonthUpDownRange+'%<i class="icon icon-arrow-green"></i>'):this.oneMonthUpDownRange+"%")):"暂无")+'</em></div>'+
							'</div>'+
							'<div class="item-subtitle"><span class="tag">'+tagStr+'</span></div>'+
						'</div>'+
					'</a><a class="button collection collection02" onclick="removeCollect(\''+this.city+'\',\''+this.region+'\',\''+this.name+'\',this)">取消关注</a>'+
				'</li>';
    });
    // 添加新条目
    $('#mf_ul').append(html);
    if(mf_totalCount<=mf_itemsPerLoad){
    	// 加载完毕，则注销无限加载事件，以防不必要的加载
		// $.detachInfiniteScroll($('.infinite-scroll'));
        // 删除加载提示符
        $('#loadTip2').remove();
    }
    if(data.results.length<mf_itemsPerLoad){
    	$('#loadTip2').remove();
    	return;
    }
	}).catch(function(error){
		console.log(error)
	});
}

// 取消关注
function removeCollect(city,region,name,obj){
	axios.post("/rest/districts/removeCollect",{city:city,region:region,name:name}).then(function (response) {
		var msg = response.data.message
		if(msg){
			$.toast(msg);
		} else {
			$.toast("取消关注");
		}
		/*mf_curpage = 1;
		$("#mf_ul").html("");
		addEstate(mf_itemsPerLoad, 0);*/
		$(obj).parent().remove();
		mf_totalCount = mf_totalCount - 1;
		  $("#mf_num").html("关注("+mf_totalCount+")")
	})
	.catch(function (error) {
	   console.log(error);
	});
}