

Vue.component('city_increase_ranking',{
	template:'<div class="list-block media-list cityList">'+
				'<ul>'+
					'<li>'+
						'<a class="item-content">'+
							'<div class="item-inner">'+
								'<div class="item-subtitle row">'+
									'<div class="col-5">&nbsp;</div>'+
									'<div class="col-20">城市</div>'+
									'<div class="col-25">上月均价</div>'+
									'<div class="col-25">近30天涨跌幅</div>'+
									'<div class="col-20"></div>'+
								'</div>'+
							'</div>'+
						'</a>'+
					'</li>'+
					'<li v-for="(ci,index) in cityIncreaseRankingList" :key="ci.city">'+
						'<a class="item-content">'+
							'<div class="item-inner">'+
								'<div class="item-subtitle row">'+
									'<div class="col-5">{{index+1}}</div>'+
									'<div class="col-20">{{ci.city}}</div>'+
									'<div class="col-25">{{!ci.cityTopMonthAvgPrice||ci.cityTopMonthAvgPrice==""?"暂无":""+ci.cityTopMonthAvgPrice+"元/㎡"}}</div>'+
									'<div class="col-25">'+
										'<em class="up">{{!ci.oneMonthUpDownRange||ci.oneMonthUpDownRange==""?"暂无":Math.abs(100*ci.oneMonthUpDownRange).toFixed(2)+"%"}}<i class="icon" v-bind:class="[ci.oneMonthUpDownRange>0?&quot;icon-arrow-red&quot;:&quot;&quot;,ci.oneMonthUpDownRange<0?&quot;icon-arrow-green&quot;:&quot;&quot;]"></i></em>'+
									'</div>'+
									'<div class="col-20">'+
										'<i class="button collection collection02 confirm-ok" v-on:click="abolish(ci.city,$event, 1)" v-if="ci.follow">取消</i>'+
										'<i class="button theme collection collection01 confirm-ok" v-on:click="follow(ci.city,$event, 0)" v-else>关注</i>'+
									'</div>'+
								'</div>'+
							'</div>'+
						'</a>'+
					'</li>'+
				'</ul>'+
			'</div>',
	data:function(){
		return cityIncreaseRankingData;
	},
	methods:{
		loadCityIncreaseRanking:function(){
			axios.get("/rest/quotations/markUpTopInfos").then(function(response){
				cityIncreaseRankingData.cityIncreaseRankingList = response.data.data;
			}).catch(function(error){
				console.log(error)
			})
		},
		follow:function(city,event, type){
			
			if(localStorage.getItem("user_token") == null || localStorage.getItem("user_token") == ""){
				clicked('/views/user/codeSms.html',true,false,{},{},function(){
					if(localStorage.getItem("user_token") == null || localStorage.getItem("user_token") == ""){
					}else{
						$.confirm('您确定要关注'+city+"?", function () {
						 	axios.get("/rest/quotations/collectCity",{params:{city:city, type:type}}).then(function(response){
								var msg = response.data.message;
								if(msg != "取消关注成功" && msg != "关注成功"){
									$.toast(msg);
									if (plus.webview.getWebviewById('views/house/houseDetail.html') != null) {
										plus.webview.getWebviewById('views/house/houseDetail.html').reload(); 
									}
								}else{
									//$(event.target).parent().children().removeClass("dn");
									//$(event.target).addClass("dn");
									
									var increaseList = cityIncreaseRankingData.cityIncreaseRankingList
									
									if(increaseList && increaseList.length>0){
										for(var i in increaseList){
											var dd = increaseList[i];
											if(dd.city == city){
												if(type == 0){
													dd.follow = true;
												}else{
													dd.follow = false;
												}
												break;
											}
										}
									}
											

									if(plus.webview.getWebviewById('views/house/houseDetail.html')!= null) {
										plus.webview.getWebviewById('views/house/houseDetail.html').reload(); 
									}

//									loadMyCollectCity()
									if(type == 0){
										var curDatas = cityDetaiVue.$data.citys
										if(curDatas && curDatas.length>=0){
											if(!IsInArray(curDatas, city)){
												cityDetaiVue.$data.citys.push(city);
											}
										}
									}
								}
										
							}).catch(function(error){
								console.log(error)
							})
				        },function(){
				        	if (plus.webview.getWebviewById('views/house/houseDetail.html') != null) {
								plus.webview.getWebviewById('views/house/houseDetail.html').reload(); 
							}
				        });
				        if(plus.webview.getWebviewById('views/house/houseManageList.html') != null) {
				        	plus.webview.getWebviewById('views/house/houseManageList.html').reload();  
				        }
				        if(plus.webview.getWebviewById('views/user/userInfo.html') != null) {
				          	plus.webview.getWebviewById('views/user/userInfo.html').reload();
				        }
						
					}
				})
			}else{
				 $.confirm('您确定要关注'+city+"?", function () {
				 	axios.get("/rest/quotations/collectCity",{params:{city:city, type:type}}).then(function(response){
						var msg = response.data.message;
						if(msg != "取消关注成功" && msg != "关注成功"){
							$.toast(msg);
						}else{
							//$(event.target).parent().children().removeClass("dn");
							//$(event.target).addClass("dn");
							
							var increaseList = cityIncreaseRankingData.cityIncreaseRankingList
							
							if(increaseList && increaseList.length>0){
								for(var i in increaseList){
									var dd = increaseList[i];
									if(dd.city == city){
										if(type == 0){
											dd.follow = true;
										}else{
											dd.follow = false;
										}
										break;
									}
								}
							}
									
							reloadMyFocus()
							reloadCityPotentialRanking()
							if(type == 0){
								var curDatas = cityDetaiVue.$data.citys
								if(curDatas && curDatas.length>=0){
									if(!IsInArray(curDatas, city)){
										cityDetaiVue.$data.citys.push(city);
									}
								}
							}
						}
								
					}).catch(function(error){
						console.log(error)
					})
		        });
			}
			
		},
		abolish:function(city,event, type){
			if(localStorage.getItem("user_token") == null || localStorage.getItem("user_token") == ""){
				clicked('/views/user/passLogin.html',true,false,{},{},function(){
					if(localStorage.getItem("user_token") == null || localStorage.getItem("user_token") == ""){
						
					}else{
						
					}
				})
			}else{
				 $.confirm("您确定要取消关注?", function () {
			            axios.get("/rest/quotations/collectCity",{params:{city:city, type:type}}).then(function(response){
							//$(event.target).parent().children().removeClass("dn");
							//$(event.target).addClass("dn");
							
							var increaseList = cityIncreaseRankingData.cityIncreaseRankingList
							
							if(increaseList && increaseList.length>0){
								for(var i in increaseList){
									var dd = increaseList[i];
									if(dd.city == city){
										if(type == 0){
											dd.follow = true;
										}else{
											dd.follow = false;
										}
										break;
									}
								}
							}
							
							reloadMyFocus();
							reloadCityPotentialRanking()
							//plus.webview.getWebviewById('views/user/userInfo.html').reload()
							var da = cityDetaiVue.$data.citys
							if(da && da.length>0){
								var index = da.indexOf(city)
								if(index>0){
									da.splice(index, 1)
									cityDetaiVue.$data.citys = da;
								}
							}
						}).catch(function(error){
							console.log(error)
						})
			     });
			}
			
		}
	},
	mounted:function(){
		this.loadCityIncreaseRanking();
	}
})

