var myFocusDatas = {myFocusList: []};
Vue.component('my_focus',{
  template:
      '<div class="topic">'+
        '<div class="topicTitle">我的关注</div>'+
        '<div class="list-block media-list cityList">'+
          '<ul>'+
            '<li>'+
              '<a class="item-content">'+
                '<div class="item-inner">'+
                  '<div class="item-subtitle row">'+
                    '<div class="col-5">&nbsp;</div>'+
                    '<div class="col-20">城市</div>'+
                    '<div class="col-25">上月均价</div>'+
                    '<div class="col-25">近30天涨跌幅</div>'+
                    '<div class="col-20">全国涨幅排名</div>'+
                  '</div>'+
                '</div>'+
              '</a>'+
            '</li>'+
            '<li v-for="(mf,index) in myFocusList">'+
              '<a class="item-content">'+
                '<div class="item-inner">'+
                  '<div class="item-subtitle row">'+
                    '<div class="col-5">{{index+1}}</div>'+
                    '<div class="col-20">{{mf.city}}</div>'+
                    '<div class="col-25">{{!mf.cityTopMonthAvgPrice||mf.cityTopMonthAvgPrice==""?"暂无":""+mf.cityTopMonthAvgPrice+"元/㎡"}}</div>'+
                    '<div class="col-25">'+
                      '<em class="up">{{!mf.oneMonthUpDownRange||mf.oneMonthUpDownRange==""?"暂无":Math.abs(mf.oneMonthUpDownRange*100).toFixed(2)+"%"}}<i class="icon" v-bind:class="[mf.oneMonthUpDownRange>0?&quot;icon-arrow-red&quot;:&quot;&quot;,mf.oneMonthUpDownRange<0?&quot;icon-arrow-green&quot;:&quot;&quot;]"></i></em>'+
                    '</div>'+
                    '<div class="col-20">'+
                      '<em>{{mf.rangeLevel}}</em>'+
                    '</div>'+
                  '</div>'+
                '</div>'+
              '</a>'+
            '</li>'+
          '</ul>'+
        '</div>'+
      '</div>'
      ,
  data:function(){
    return myFocusDatas;
  },
  methods:{
    loadMyFocus:function(){
      if(localStorage.getItem("user_token") == null || localStorage.getItem("user_token") == ""){
        $("#myFocusFirstPage").hide()
        $("#myFocus").hide();
      }else{
        axios.get("/rest/quotations/userCollectCityInfo").then(function(response){
          if(response.data.data.length==0){
            $("#myFocusFirstPage").hide();
            $("#myFocus").hide();
          }else{
            myFocusDatas.myFocusList = response.data.data;
          }
        }).catch(function(error){
        	console.log(error)
        })
      }
    }
  },mounted:function(){
      this.loadMyFocus();
    }  
})

