 String.prototype.startWith=function(str){     
  var reg=new RegExp("^"+str);     
  return reg.test(this);        
}  

/**
 * 推送处理业务逻辑
 * yinjihuan
 */
document.addEventListener("plusready", function() {
    // 监听点击消息事件
    plus.push.addEventListener("click", function(msg) {
    	//刷新个人中心
    	if (plus.webview.getWebviewById('views/user/userInfo.html') != null) {
			plus.webview.getWebviewById('views/user/userInfo.html').reload(); 
		}
        // 判断是从本地创建还是离线推送的消息
        var payload = msg.payload;
        var title = msg.title;
        var content = msg.content;
        switch(payload) {
            case "LocalMSG":
                alert("点击本地创建消息启动：");
                break;
            default:
                if (plus.os.name == "Android"){
                	try {
                		payload = JSON.parse(payload);
                	} catch(err) {
                		
                	}
                	if (payload.type == "0") {
                   		 plus.ui.alert(title+"\n"+content);
	                } else if (payload.type == "1") {
	                	if(plus.webview.getWebviewById('H5693FF3D')==null){
					   		plus.webview.show(plus.webview.getWebviewById("HBuilder"));
					    }else{
					   		plus.webview.show(plus.webview.getWebviewById("H5693FF3D"));
					    }
					    var targetTab = payload.url+".html";
					    var defaultTab = document.getElementById(targetTab);
						//模拟首页点击
						mui.trigger(defaultTab, 'tap');
						//切换选项卡高亮
						var current = document.querySelector(".mui-bar-tab>.mui-tab-item.mui-active");
						if (defaultTab != current) {
							current.classList.remove('mui-active');
							defaultTab.classList.add('mui-active');
						}
	                	
	                } else if (payload.type == "2") {
	           	       	if (payload.url.startWith("http")) {
	           	       		clicked('views/webview_embed.html', true,false,{},{url:payload.url})
                    	} else {
                    		// 处理打开app中的二级页面，一级页面在type=1中已经处理了，如果有http的地址就是打开外部页面
                    		// 否则就是打开app内部页面
                    		var url = payload.url;
           	       		 	var sindex = url.indexOf('?') == -1 ? url.length : url.indexOf('?');
							var openUrl = url.substring(0, sindex);
							var paramStr = url.substring(sindex+1);
							var jsonData = {};
							var parray = paramStr.split('&')
							for(var i=0;i<parray.length;i++){
								var subArray = parray[i].split('=')
								if(parray[i] != ""){
									if(subArray.length > 0) {
										 jsonData[subArray[0]] = subArray[1];
									}
								}
							}
							clicked(openUrl,true,false,{},jsonData)
							
                    	}
	               	}
                } else {
                	if (payload.type == "0") {
                   		 plus.ui.alert(content);
                    } else if (payload.type == "1") {
                    	if(plus.webview.getWebviewById('H5693FF3D')==null){
					   		plus.webview.show(plus.webview.getWebviewById("HBuilder"));
					    }else{
					   		plus.webview.show(plus.webview.getWebviewById("H5693FF3D"));
					    }
					    var targetTab = payload.url+".html";
					    var defaultTab = document.getElementById(targetTab);
						//模拟首页点击
						mui.trigger(defaultTab, 'tap');
						//切换选项卡高亮
						var current = document.querySelector(".mui-bar-tab>.mui-tab-item.mui-active");
						if (defaultTab != current) {
							current.classList.remove('mui-active');
							defaultTab.classList.add('mui-active');
						}
							
                    } else if (payload.type == "2") {
                    	if (payload.url.startWith("http")) {
                    		clicked('views/webview_embed.html', true,false,{},{url:payload.url})
                    	} else {
                    		// 处理打开app中的二级页面，一级页面在type=1中已经处理了，如果有http的地址就是打开外部页面
                    		// 否则就是打开app内部页面
                    		var url = payload.url;
           	       		 	var sindex = url.indexOf('?') == -1 ? url.length : url.indexOf('?');
							var openUrl = url.substring(0, sindex);
							var paramStr = url.substring(sindex+1);
							var jsonData = {};
							var parray = paramStr.split('&')
							for(var i=0;i<parray.length;i++){
								var subArray = parray[i].split('=')
								if(parray[i] != ""){
									if(subArray.length > 0) {
										 jsonData[subArray[0]] = subArray[1];
									}
								}
							}
							clicked(openUrl,true,false,{},jsonData) 
							
                    	}
	           	       	 
              	 	}
                }
            	
                break;
        }
    }, false);
     
    // 监听在线消息事件, iOS透传消息在线时会进入这里进行处理
    plus.push.addEventListener("receive", function(msg) {
    	//刷新个人中心
    	if (plus.webview.getWebviewById('views/user/userInfo.html') != null) {
			plus.webview.getWebviewById('views/user/userInfo.html').reload(); 
		}
        var title = msg.title;
        var content = msg.content;
        var payload = msg.payload;
        if (payload.type == "0") {
        	 plus.ui.alert(title+"\n"+content);
        } else if (payload.type == "1") {
        	
        	plus.nativeUI.confirm(content, function(e){  
				if (e.index==0) {
					if (payload.url == '/house/index') {
	        	 		 plus.webview.show('yfindex.html');
	        	 	} else {
	        	 		 plus.webview.show(BASE_PATH + payload.url);
	        	 	}
	        	
	        	 	//切换选项卡高亮
					var defaultTab = document.getElementById("defaultTab");
					var quotations = document.getElementById("quotations");
					var selfInfo = document.getElementById("selfInfo");
					defaultTab.classList.remove("mui-active");
					quotations.classList.remove("mui-active");
					selfInfo.classList.remove("mui-active");
					if (payload.url == '/quotations/index') {
						quotations.classList.add("mui-active");
					} else if(payload.url == '/selfInfo/index') {
						selfInfo.classList.add("mui-active");
					} else {
						defaultTab.classList.add("mui-active");
					}
					}
				}, title, ["查看","忽略"] );  
							
        } else if (payload.type == "2") {
	       	plus.nativeUI.confirm(content, function(e){  
				if (e.index==0) {
					if (payload.url.startWith("http")) {
                    	clicked('views/webview_embed.html', true,false,{},{url:payload.url})
                	} else {
                		var url = payload.url;
	   	       		 	var sindex = url.indexOf('?') == -1 ? url.length : url.indexOf('?');
						var openUrl = url.substring(0, sindex);
						var paramStr = url.substring(sindex+1);
						var jsonData = {};
						var parray = paramStr.split('&')
						for(var i=0;i<parray.length;i++){
							var subArray = parray[i].split('=')
							if(parray[i] != ""){
								if(subArray.length > 0) {
									 jsonData[subArray[0]] = subArray[1];
								}
							}
						}
						clicked(openUrl,true,false,{},jsonData)
                	}
					
				}
			}, title, ["查看","忽略"] );  
							
    	}
    }, false);
}, false);

